using UnityEngine;using System.Collections;namespace PluginIdea.Fluid{public class SSF_FluidRenderer : MonoBehaviour{public bool isRandomSize = true;public ParticleSystem m_ps;public int m_particlesCount = 0;private Color m_color = Color.gray;public float m_pointScale = 1.0f;public float m_pointRadius = 0.02f;public bool m_blur = true;public float m_blurScale = 1f;public int m_blurRadius = 10;public float m_blurDepthFalloff = 100.0f;public float m_minDepth = 0.0f;public float m_thickness = 1.0f;public float m_softness = 1.0f;public bool iaAlignParticleSize;public float hStrengh = 1;public float vStrengh = 1;public float vOffset = 0.5f;public float hBaseOffset = 1f;public float vBaseOffset = 1f;public float hExStrengh = 0f;private Material m_colorMaterial;private Material m_depthMaterial;private Material m_blurDepthMaterial;private Material m_thicknessMaterial;private ComputeBuffer m_posBuffer;private ComputeBuffer m_colorBuffer;private ComputeBuffer m_quadVerticesBuffer;private ComputeBuffer m_velocityBuffer;private Vector4[] m_positions;private Vector3[] m_velocities;private Color[] m_colors;private ParticleSystem.Particle[] m_particles;private Camera windowCamera, screenShotCamera;void Start(){windowCamera = Utils.GetWindowCamera();m_ps = GetComponent<ParticleSystem>();m_colorMaterial = new Material(SSF.dic_name2Shaders["ScreenSpaceFluids/SSF_SpherePointsShader"]);m_depthMaterial = new Material(SSF.dic_name2Shaders["ScreenSpaceFluids/SSF_DepthShader"]);m_thicknessMaterial = new Material(SSF.dic_name2Shaders["ScreenSpaceFluids/SSF_ThicknessShader"]);m_blurDepthMaterial = new Material(SSF.dic_name2Shaders["ScreenSpaceFluids/SSF_BlurDepth"]);m_colorMaterial.hideFlags = HideFlags.HideAndDontSave;m_depthMaterial.hideFlags = HideFlags.HideAndDontSave;m_thicknessMaterial.hideFlags = HideFlags.HideAndDontSave;m_blurDepthMaterial.hideFlags = HideFlags.HideAndDontSave;m_particles = new ParticleSystem.Particle[m_ps.maxParticles];m_positions = new Vector4[m_ps.maxParticles];m_velocities = new Vector3[m_ps.maxParticles];;m_colors = new Color[m_ps.maxParticles];;m_posBuffer = new ComputeBuffer(m_ps.maxParticles, 16);m_colorBuffer = new ComputeBuffer(m_ps.maxParticles, 16);m_velocityBuffer = new ComputeBuffer(m_ps.maxParticles, 12);m_particlesCount = m_ps.GetParticles(m_particles);for (int i = 0;i < m_ps.particleCount;i++){m_positions[i] = m_particles[i].position;m_positions[i].w = isRandomSize ? m_particles[i].GetCurrentSize(m_ps) : 1;m_velocities[i] = m_particles[i].velocity;m_colors[i] = m_particles[i].GetCurrentColor(m_ps);}m_posBuffer.SetData(m_positions);m_colorBuffer.SetData(m_colors);m_velocityBuffer.SetData(m_velocities);m_quadVerticesBuffer = new ComputeBuffer(6, 16);m_quadVerticesBuffer.SetData(new[]{new Vector4(-0.5f, 0.5f),            new Vector4(0.5f, 0.5f),            new Vector4(0.5f, -0.5f),            new Vector4(0.5f, -0.5f),            new Vector4(-0.5f, -0.5f),            new Vector4(-0.5f, 0.5f),});m_depthMaterial.SetBuffer("buf_Positions", m_posBuffer);m_depthMaterial.SetBuffer("buf_Vertices", m_quadVerticesBuffer);m_depthMaterial.SetBuffer("buf_Velocities", m_velocityBuffer);m_thicknessMaterial.SetBuffer("buf_Positions", m_posBuffer);m_thicknessMaterial.SetBuffer("buf_Colors", m_colorBuffer);m_thicknessMaterial.SetBuffer("buf_Vertices", m_quadVerticesBuffer);m_thicknessMaterial.SetBuffer("buf_Velocities", m_velocityBuffer);}void OnRenderObject(){if (Camera.current != Utils.CenterCamera && Camera.current != windowCamera) return;m_particlesCount = m_ps.GetParticles(m_particles);for (int i = 0;i < m_particlesCount;i++){m_positions[i] = m_particles[i].position;m_positions[i].w = isRandomSize ? m_particles[i].GetCurrentSize(m_ps) : 1;m_velocities[i] = m_particles[i].velocity;m_colors[i] = m_particles[i].GetCurrentColor(m_ps);}m_posBuffer.SetData(m_positions);m_colorBuffer.SetData(m_colors);m_velocityBuffer.SetData(m_velocities);DrawDepth();if (m_blur){BlurDepth();}else{Graphics.Blit(SSF.m_depthTexture, SSF.m_blurredDepthTexture);}DrawThickness();}void DrawDepth(){m_depthMaterial.SetVector("_ShapePara1", new Vector4(hStrengh, vStrengh, vOffset));m_depthMaterial.SetVector("_ShapePara2", new Vector4(hBaseOffset, vBaseOffset, hExStrengh));m_depthMaterial.SetFloat("_PointRadius", m_pointRadius);m_depthMaterial.SetFloat("_PointScale", m_pointScale);m_depthMaterial.SetBuffer("buf_Positions", m_posBuffer);m_depthMaterial.SetBuffer("buf_Colors", m_colorBuffer);m_depthMaterial.SetBuffer("buf_Vertices", m_quadVerticesBuffer);m_depthMaterial.SetBuffer("buf_Velocities", m_velocityBuffer);Graphics.SetRenderTarget(SSF.m_depthTexture);GL.Clear(true, true, Color.white);m_depthMaterial.SetPass(0);Graphics.DrawProcedural(MeshTopology.Triangles, 6, m_ps.particleCount);}void BlurDepth(){m_blurDepthMaterial.SetTexture("_DepthTex", SSF.m_depthTexture);m_blurDepthMaterial.SetInt("radius", m_blurRadius);m_blurDepthMaterial.SetFloat("minDepth", m_minDepth);m_blurDepthMaterial.SetFloat("blurDepthFalloff", m_blurDepthFalloff);m_blurDepthMaterial.SetTexture("_DepthTex", SSF.m_depthTexture);m_blurDepthMaterial.SetFloat("scaleX", 1.0f / 1024 * m_blurScale);m_blurDepthMaterial.SetFloat("scaleY", 0.0f);Graphics.Blit(SSF.m_depthTexture, SSF.m_blurredDepthTempTexture, m_blurDepthMaterial);m_blurDepthMaterial.SetTexture("_DepthTex", SSF.m_blurredDepthTempTexture);m_blurDepthMaterial.SetFloat("scaleX", 0.0f);m_blurDepthMaterial.SetFloat("scaleY", 1.0f / 1024 * m_blurScale);Graphics.Blit(SSF.m_blurredDepthTempTexture, SSF.m_blurredDepthTexture, m_blurDepthMaterial);}void DrawThickness(){m_thicknessMaterial.SetVector("_ShapePara1", new Vector4(hStrengh, vStrengh, vOffset));m_thicknessMaterial.SetVector("_ShapePara2", new Vector4(hBaseOffset, vBaseOffset, hExStrengh));m_thicknessMaterial.SetFloat("_PointRadius", m_pointRadius);m_thicknessMaterial.SetFloat("_PointScale", m_pointScale);m_thicknessMaterial.SetFloat("_Thickness", m_thickness);m_thicknessMaterial.SetFloat("_Softness", m_softness);m_thicknessMaterial.SetBuffer("buf_Positions", m_posBuffer);m_thicknessMaterial.SetBuffer("buf_Colors", m_colorBuffer);m_thicknessMaterial.SetBuffer("buf_Vertices", m_quadVerticesBuffer);m_thicknessMaterial.SetBuffer("buf_Velocities", m_velocityBuffer);Graphics.SetRenderTarget(SSF.m_thicknessTexture);GL.Clear(true, true, Color.black);m_thicknessMaterial.SetPass(0);Graphics.DrawProcedural(MeshTopology.Triangles, 6, m_ps.particleCount);}void OnDestroy(){ReleaseBuffers();}void ReleaseBuffers(){if (m_posBuffer != null)                m_posBuffer.Release();if (m_colorBuffer != null)                m_colorBuffer.Release();if (m_quadVerticesBuffer != null)                m_quadVerticesBuffer.Release();if (m_velocityBuffer != null)                m_velocityBuffer.Release();}}}